--Fish and Bids
local s,id,o=GetID()
function s.initial_effect(c)
    --Activate
	local e1=Effect.CreateEffect(c)
	e1:SetCategory(CATEGORY_DECKDES+CATEGORY_REMOVE+CATEGORY_TOGRAVE)
	e1:SetType(EFFECT_TYPE_ACTIVATE)
	e1:SetCode(EVENT_FREE_CHAIN)
	e1:SetCondition(s.condition)
	e1:SetTarget(s.target)
	e1:SetOperation(s.activate)
	c:RegisterEffect(e1)
end
function s.condition(e,tp,eg,ep,ev,re,r,rp)
	return Duel.GetCurrentPhase()==PHASE_MAIN1 and not Duel.CheckPhaseActivity()
end
function s.filter1(c,tp)
	return c:IsType(TYPE_MONSTER) and c:IsRace(RACE_FISH) and
    (c:IsAbleToGrave() and Duel.IsExistingMatchingCard(s.filter2,tp,LOCATION_DECK,0,1,c)
    or c:IsAbleToRemove() and  Duel.IsExistingMatchingCard(s.filter3,tp,LOCATION_DECK,0,1,c))
end
function s.filter2(c)
	return c:IsType(TYPE_MONSTER) and c:IsRace(RACE_FISH) and c:IsAbleToGrave()
end
function s.filter3(c)
	return c:IsType(TYPE_MONSTER) and c:IsRace(RACE_FISH) and c:IsAbleToRemove()
end
function s.target(e,tp,eg,ep,ev,re,r,rp,chk)
	if chk==0 then return Duel.IsExistingMatchingCard(s.filter1,tp,LOCATION_DECK,0,1,nil,tp) end
    Duel.SetOperationInfo(0,CATEGORY_TOGRAVE,nil,2,tp,LOCATION_HAND+LOCATION_DECK)
	Duel.SetOperationInfo(0,CATEGORY_REMOVE,nil,2,tp,LOCATION_HAND+LOCATION_DECK)
end
function s.activate(e,tp,eg,ep,ev,re,r,rp)
    local g=Duel.GetMatchingGroup(Card.IsAbleToRemove,tp,0,LOCATION_HAND,nil,1-tp)
    if #g>0 and Duel.IsChainDisablable(0) and Duel.SelectYesNo(1-tp,aux.Stringid(id,0)) then
        Duel.Hint(HINT_SELECTMSG,1-tp,HINTMSG_REMOVE)
        local tc=g:Select(1-tp,1,1,nil):GetFirst()
        Duel.Remove(tc,POS_FACEUP,REASON_EFFECT)
        Duel.NegateEffect(0)
		return
	end
    local g1=Duel.GetMatchingGroup(s.filter1,tp,LOCATION_DECK,0,nil,tp)
	if g1:GetCount()>0 then
		Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_OPERATECARD)
		local sg1=g1:Select(tp,1,1,nil)
		Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_OPERATECARD)
		local sg2=Duel.SelectMatchingCard(tp,s.filter2,tp,LOCATION_DECK,0,1,1,sg1:GetFirst())
		sg1:Merge(sg2)
		if sg1 and sg1:GetFirst():IsAbleToGrave() and sg2:GetFirst():IsAbleToGrave() and (not sg1:GetFirst():IsAbleToRemove() or not sg2:GetFirst():IsAbleToRemove() or Duel.SelectOption(tp,1191,1192)==0) then
			Duel.SendtoGrave(sg1,REASON_EFFECT)
		else
			Duel.Remove(sg1,POS_FACEUP,REASON_EFFECT)
		end
	end
end